/* 

Class rmTabBook     	A custom "fake" tabbed notebook which uses and
                     switches form pages.

      Author:	   	Ronnie MacGregor

      Date:		   	2002 03

      Copyright:  	Ronnie MacGregor. All rights reserved.

                     This control is offered as "freeware" to dBASE
                     developers, but must be credited to the author.

                     It is the duty of the user to determine it's 
                     suitability for use. In no circumstance will the
                     author accept any responsibility for any 
                     consequence arising from it's use.

*/


Class rmTabBook(oF) of Container(oF) Custom
   with (this)
      parent.metric := 6 // Pixels 
      transparent = true
      borderStyle = 3	// None
      width = 200
      height = 100
      pageno = 0
   endwith

   this.TabCount = 0
   this.NextTabLeft = 0
   this.CurrentColour = "C0C0C0"
   this.CurrentTabLeft = 0
   this.CurrentTabWidth = 0

   // Winapi prototypes //////////////

   if type("InvalidateRect") # "FP"
      extern CVOID InvalidateRect( CHANDLE,CPTR,CLOGICAL ) USER32
   endif

   if type("GetClientRect") # "FP"
      extern clogical GetClientRect(chandle, cptr) user32
   endif

   if type("BeginPaint") # "FP"
      extern CHANDLE BeginPaint(CHANDLE, CPTR) USER32
   endif 

   if type("EndPaint") # "FP"
      extern CVOID EndPaint(CHANDLE, CPTR) USER32
   endif 

   if type("SelectObject") # "FP"
      extern CHANDLE SelectObject(CHANDLE, CHANDLE) GDI32
   endif 

   if type("CreatePen") # "FP"
      extern CHANDLE CreatePen(CINT, CINT, CLONG) GDI32
   endif 

   if type("UpdateWindow") # "FP"
      extern CVOID UpdateWindow(CHANDLE) USER32
   endif

   if type("DeleteObject") # "FP"
      extern CLOGICAL DeleteObject(CHANDLE) GDI32
   endif 

   if type("CreateSolidBrush") # "FP"
      extern CHANDLE CreateSolidBrush(CLONG) GDI32
   endif 

   // TextOut(hDC, nTopLeftX, nTopLeftY, cText, len(cText))
   if type("TextOut") # "FP" 
      extern clogical TextOut(chandle, cint, cint, cptr, cint) gdi32 from "TextOutW"
   endif

   // Rectangle(hDC, nTopLeft x, nTopLeftY, nBotRightX, nBotRightY)
   if type("Rectangle") # "FP" 
      extern clogical Rectangle(cHandle, CINT, CINT, CINT, CINT) gdi32
   endif

   // Put pen at given point
   // MoveToEx(hdc, nXPos, nYPos, NULL)
   if type("MoveToEX") # "FP"
      extern clogical MoveToEx(chandle, cint, cint, cptr) gdi32
   endif

   // Draw Line from current pen position to given point
   // LineTo(hdc, nXPos, nYPos)
   if type("LineTo") # "FP"
         extern clogical LineTo(chandle, cint, cint) gdi32
   endif

   // Round Rectangle
   // RoundRect(hDC, nTopLeftX, nTopLeftY, nBottRightX, nBottRightY, nRoundX, nRoundY)
   if type("RoundRect") # "FP"
      extern clogical RoundRect(chandle, CINT, CINT, CINT, CINT, CINT, CINT) gdi32
   endif

   //Arc
   if type("Arc") # "FP"
      extern clogical Arc(chandle, CINT, CINT, CINT, CINT, CINT, CINT,CINT, CINT) gdi32
   endif

   // AngleArc
   if type("AngleArc") # "FP"
      extern clogical AngleArc(chandle, CINT, CINT, CINT, CFLOAT, CFLOAT) gdi32
   endif

   if type("SetBkMode") # "FP"
      extern CINT SetBkMode(chandle, CINT) gdi32
   endif

   if type("CreateFont") # "FP"
      extern CLONG CreateFont(CINT, CINT, CINT, CINT, CINT, CINT, ;
                   CINT, CINT, CINT, CINT, CINT, ;
                   CINT, CINT, CPTR) gdi32 from "CreateFontA"
   endif

   ////////////////////////////

   this.PageArea = new PaintBox(this)
   with (this.PageArea)
      onPaint = class::PaintPageArea
      left = 0
      top = 25
      width = 200
      height = 75
      ColorNormal =   "N/" + this.parent.ColorNormal
   endwith

   ////////////////////////////

   function PaintPageArea()

      // ? "PageArea onPaint fired" 

      local hDC, hDefPen, hDefBrush, xPaint, hwnd

      this.width = (this.parent.width)
      this.height = (this.parent.height - 25)
      tw = this.width
      th = this.height
       
      xPaint  = space(32) //throw-away buffer
      
      // invalidate complete control to make repainting ready
      invalidateRect(this.hWND, 0, true)

      // Start the paint run
      hDC = beginpaint(this.hWND, xPaint)
     
      // Draw White Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("FFFFFF")))
      // Left
      MoveToEx(hdc, 0, 0, NULL)
      LineTo(hdc, 0, (th-1))
      // Top
      MoveToEx(hdc, 0, 0, NULL)
      LineTo(hdc, (tw-2), 0)
      deleteobject(selectobject(hDC, hDefPen))

      // Draw Light Grey BorderLines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("EFEFEF")))
      // Left
      MoveToEx(hdc, 1, 0, NULL)
      LineTo(hdc, 1, (th-2))
      //Top
      MoveToEx(hdc, 1, 1, NULL)
      LineTo(hdc, (tw-3), 1)
      deleteobject(selectobject(hDC, hDefPen))

      // Draw Black Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("2B2B2B")))
      MoveToEx(hdc, 1, (th-1), NULL)
      LineTo(hdc, (tw-1), (th-1))
      LineTo(hdc, (tw-1), 0)
      deleteobject(selectobject(hDC, hDefPen))

      // Draw Dark Grey Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("999999")))
      MoveToEx(hdc, 1, (th-2), NULL)
      LineTo(hdc, (tw-2), (th-2))
      LineTo(hdc, (tw-2), 1)
      deleteobject(selectobject(hDC, hDefPen))
            
      // Draw Rectangle
      tpCCol = (this.parent.CurrentColour)
      hDefPen = selectobject(hDC, createpen(0, 1, htoi(tpCCol)))
      hDefBrush = selectobject(hDC, createsolidbrush(htoi(tpCCol)))
      Rectangle(hDC, 2, 2, (tw-2), (th-2))

      // Draw Top Edge Break
      nTabStart = (this.parent.CurrentTabLeft)
      nTabStop = (this.parent.CurrentTabLeft) + (this.parent.CurrentTabWidth)
      Rectangle(hDC, (nTabStart + 2), 0, (nTabStop - 1), 1)
      Rectangle(hDC, nTabStart + 2, 1, nTabStop, 2)
      deleteobject(selectobject(hDC, hDefPen))
      deleteobject(selectobject(hDC, hDefBrush))
  
      // Finish Painting
      EndPaint(this.hWND,xPaint) 
   
   return

   ////////////////////////////

   function TabBookSetup(cTabText,cTabColour,nTabTargetPage,nTabWidth)
      private sMacString
      //
      this.TabCount = this.TabCount + 1
      if this.TabCount = 1
         this.CurrentColour = substr(cTabColour,3)
         this.CurrentTabWidth = (nTabWidth)
      endif
      //
      sMacString = "this.PAINTTAB" + this.TabCount + "= new PAINTTAB(this)"
      &sMacString. 
      sMacString = "this.PAINTTAB" + this.TabCount + ".left = " + this.NextTabLeft 
      &sMacString.
      sMacString = "this.PAINTTAB"+ this.TabCount +[.TabText = "]+cTabText+["]
      &sMacString.
      sMacString = "this.PAINTTAB" + this.TabCount + [.TabColour = "] + substr(cTabColour,3) + ["] 
      &sMacString.
      sMacString = "this.PAINTTAB"+ this.TabCount +".TabTargetPage = " + nTabTargetPage
      &sMacString.
      sMacString = "this.PAINTTAB"+ this.TabCount +".width = " + nTabWidth
      &sMacString.
      //
      this.NextTabLeft += nTabWidth
      //
   return

   ////////////////////////////

endclass

//////////////////////////////////////////////
//////////////////////////////////////////////

class PaintTab(f) Of paintbox(f) Custom
   with (this)
      onLeftMouseDown = class::PaintTabOnLeftMouseDown
      top = 0
      height = 25
      width = 80
      left = 0
      ColorNormal =   "N/" + this.parent.parent.ColorNormal
      pageno = 0
   endwith


   // Custom properties
   this.TabText = "TabText"
   this.TabColour = "C0C0C0"
   this.TabTargetPage = 0
   

   Procedure OnPaint(lSelected)

      // ? "Tab onpaint for : " + this.name + " " + lSelected
      
      local hDC, hDefPen, hDefBrush, xPaint, hwnd
      local tw, th, drop

      tw = this.width
      th = this.height
      drop = iif(lSelected == true, 0, 2)
       
      // invalidate complete control to make repainting ready
      xPaint  = space(32) //throw-away buffer
      invalidateRect(this.hWND, 0, true)

      // Start the paint run
      hDC = beginpaint(this.hWND, xPaint)

      // Draw Tab 
      hDefPen = selectobject(hDC, createpen(0, 1, htoi(this.TabColour)))
      hDefBrush = selectobject(hDC, createsolidbrush(htoi(this.TabColour)))
      Rectangle(hDC, 3, 2 + drop, (tw - 3), 3 + drop) 
      Rectangle(hDC, 2, 3 + drop, (tw - 2), th)
      deleteobject(selectobject(hDC, hDefPen))
      deleteobject(selectobject(hDC, hDefBrush))

      // Draw Black Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("2B2B2B")))
      MoveToEx(hdc, (tw - 1), (th - 1), NULL)
      LineTo(hdc, (tw - 1), 3 + drop)
      LineTo(hdc, (tw - 4), 0 + drop)
      deleteobject(selectobject(hDC, hDefPen))

      // Draw Dark Grey Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("999999")))
      MoveToEx(hdc, (tw - 2), (th - 1), NULL)
      LineTo(hdc, (tw - 2), 3 + drop)
      LineTo(hdc, (tw - 4), 1 + drop)
      deleteobject(selectobject(hDC, hDefPen))
      
      // Draw White Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("FFFFFF")))
      MoveToEx(hdc, (tw - 5), 0 + drop, NULL)
      LineTo(hdc, 3, 0 + drop)
      LineTo(hdc, 0, 3 + drop)
      LineTo(hdc, 0, th)
      deleteobject(selectobject(hDC, hDefPen))
            
      // Draw Light Grey Border Lines
      hDefPen = selectobject(hDC, createpen(0, 1, htoi("EFEFEF")))
      MoveToEx(hdc, (tw - 4), 1 + drop, NULL)
      LineTo(hdc, 3, 1 + drop)
      LineTo(hdc, 1, 3 + drop)
      LineTo(hdc, 1, th)
      deleteobject(selectobject(hDC, hDefPen))
      
      // Draw text
      SetBkMode(hdc, 0) // Transparent
      hFont = CreateFont(16,0,0,0,400,0,0,0,0,0,0,4,0,"Arial")
      hOldFont = selectobject(hdc, hFont)
      TextOut(hDC, 10, 4 + drop, this.TabText, len(this.TabText))

      // Finish Painting
      EndPaint(this.hWND,xPaint) 
      
   
   return


   function PaintTabOnLeftMouseDown()

      // Paint standard tabs
      private sMacString
      local nCount
      for nCount = 1 to this.parent.TabCount
         // fire each tabs onPaint 
         sMacString = "this.parent.PAINTTAB" + nCount + ".onPaint()"
         &sMacString.
      endfor // next

      // Paint selected tab
      this.onPaint(true)

      // Paint PageArea
      this.parent.CurrentColour = (this.TabColour)
      this.parent.CurrentTabLeft = (this.left)
      this.parent.CurrentTabWidth = (this.width)
      form.pageno = this.TabTargetPage
      // Changing the form page initiates a repaint
      // but is not 100% reliable - so force
      this.parent.PageArea.onPaint()

   return
   

EndClass
